function [ imstreakdx, lb, ub ] = cropBackground( imstreak, imstreakdx )
%CROPBACKGROUND Elimina lo sfondo nero applicato dopo
%               la rotazione dell'immagine
%   Parametri:
%       imstreak:   immagine striscia
%       imstreakdx: derivata immagine striscia

[m,n] = size(imstreak);

% determina il bound di taglio sinistro
break1 = 0;
break2 = 0;
for k=1:n
    if(imstreak(1,k) > 0)
        xf = k;
        break1 = 1;
    end
    if(imstreak(m,k) > 0)
        xl = k;
        break2 = 1;
    end
    if(break1 && break2)
        break;
    end
end
lb = max(xf, xl) +2;

% determina il bound di taglio destro
break1 = 0;
break2 = 0;
for k=n:-1:1
    if(imstreak(1,k) > 0)
        xf = k;
        break1 = 1;
    end
    if(imstreak(m,k) > 0)
        xl = k;
        break2 = 1;
    end
    if(break1 && break2)
        break;
    end
end
ub = min(xf, xl) -2;

if(lb <= ub)
    imstreakdx = imstreakdx(:,lb:ub);
else
    % non ritagliare la derivata
end
