function [ n ] = filterRegionByArea( features, perc )
%FILTERREGIONBYAREA Ritorna il numero di aree significative scartando tutte
% le features che hanno un area minore di % dell'area massima
%   Parametri:
%       features:   features in ordine decrescente per area
%       perc:       percentuale 

area = features(:,1);
maxArea = area(1);

thres = perc * maxArea;
thArea = area > thres;
n = sum(thArea);
