function [ centers, centroids, bboxes ] = findStreaks( imbw, num, perc )
%FINDSTREAKS Summary of this function goes here
%   Parametri:
%       imbw:   immagine in bianco-nero
%       num:    filtro per numero
%       perc:   percentuale per filtro area

% identifica ed etichetta le regioni connesse
bwl = bwlabel(imbw);

% identifica le propriet delle regioni trovate
rp = regionprops(bwl, 'Centroid', 'Area', 'BoundingBox');

rparea = cat(1, rp.Area);
rpcentroids = cat(1, rp.Centroid);
rpboundingBox = cat(1, rp.BoundingBox);

% ordina per area
features = sortrows([rparea rpcentroids rpboundingBox], -1);

% filtra in base all'area
ub = filterRegionByArea(features, perc);
features = features(1:ub,:);

% filtra per numero
[m,n] = size(features);
if(num > m)
    num = m;
end

features = features(1:num,:);
centroids = features(:,2:3)';
bboxes = features(:,4:7);
centers = getBoundingBoxCenter(features(:,4:7));
