function [ imbbox point ] = getBoundingBoxImage( im, point, bbox, sizefactor )
%GETBOUNDINGBOXIMAGE Ritaglia l'immagine in base ad un boundingbox
%   Parametri
%       im:         immagine
%       point:      vettore colonna punto che verr scalato in base
%                   alle nuove dimensioni dell'immagine ritagliata
%       bbox:       boundingbox in base al quale ritagliare l'immagine
%       sizefactor: fattore di scala del ritaglio

if(nargin < 4)
    sizefactor = 1;
end

x = fix(bbox(1));
y = fix(bbox(2));
xl = bbox(3);
yl = bbox(4);

% pixel pari
%if(mod(xl,2))
%    xl = xl +1;
%end
%if(mod(yl,2))
%    yl = yl +1;
%end

% scala il box
%xm = x + xl/2;
%ym = y + yl/2;
%xl = xl * sizefactor;
%yl = yl * sizefactor;

% pixel pari
%if(mod(xl,2))
%    xl = xl +1;
%end
%if(mod(yl,2))
%    yl = yl +1;
%end

% imposta nuovi bounds
%lb = (xm - xl/2);
%ub = (xm + xl/2);
%cols = lb:ub;

%lb = (ym - yl/2);
%ub = (ym + yl/2);
%rows = lb:ub;


% scala il box
xm = x + fix(xl/2);
ym = y + fix(yl/2);
xl = xl * sizefactor;
yl = yl * sizefactor;

% imposta nuovi bounds
lb = (xm - fix(xl/2));
ub = (xm + fix(xl/2));
[lb, ub] = checkBounds(im, lb, ub, 'width');
cols = lb:ub; % larghezza

lb = (ym - fix(yl/2));
ub = (ym + fix(yl/2));
[lb, ub] = checkBounds(im, lb, ub, 'height');
rows = lb:ub; % altezza

imbbox = im(rows, cols);
point = point - [cols(1); rows(1)];
