
% ricerca delle linee dell'immagine
lines = findLines(immasked, houghFillGap, houghMinLength, -1);

% filtro delle linee in base all'angolo di inclinazione
toll = 1;
l1 = longit_c(:,(1:2));
l2 = longit_c(:,(3:4));
[olines, filtered] =  filterLinesByAngle(lines, l1, l2, toll);
[olines] =  filterLinesByIntersection(olines);
[m,n] = size(olines);

% visualizza
if(showComputation)
    figure;
    imshow(im);
    plotLine(struct2line(olines), 'g', 2, '--', '*b', '*y');
    plotLine(struct2line(filtered), 'r', 2, '--', '*b', '*y');
end

% strutture di output
ocenters = zeros(2,n);
ospeeds = zeros(1,n);
ostreaks = zeros(2,2,n);
i = 0;
for k=1:n
    % definisci traccia
    streak = [olines(k).point1' olines(k).point2'];
    
    % ordina punti (rispetto ordinata crescente)
    streak = sortrows(streak', 2)';
    
    % calcola centro
    center = mean(streak, 2);
    
    % calcola velocit approssimativa
    speed = computeSpeed(streak, v1_h, v2_h, ref_c, reflen, shutter);
    
    % stampa linee individuate
    figure(figStreaks);
    hold on;
    scatter(center(1), center(2), 'filled');
    plotLine([v1_c streak(:,2)], 'g', 2, '--');
    scatter(streak(1,1), streak(2,1), 'filled', 'g');
    scatter(streak(1,2), streak(2,2), 'filled', 'g');
    
    % stampa velocit
    plotText(streak(:,1), streak(:,2), horzcat('\leftarrow', sprintf('%3.2f Km/h', speed)), 'r', 12);
    
    % filtra per velocit
    if((speed >= minSpeed) && (speed <= maxSpeed))
        i = i +1;
        
        % riempi strutture
        ocenters(:,i) = center;
        ostreaks(:,:,i) = streak;
        ospeeds(i) = speed;
    end
end

% ridimensiona
ocenters = ocenters(:,1:i);
ostreaks = ostreaks(:,:,1:i);
ospeeds = ospeeds(1:i);
