function [ olines, filtered ] = filterLinesByAngle( lines, l1, l2, toll )
%FILTERLINESBYANGLE Filtra tutte le linee che hanno un'inclinazione non compresa fra l1 ed l2
%   Parametri:
%       lines:  struttura linee
%       l1:     matrice di vettori colonna dei 2 punti della linea 1
%       l2:     matrice di vettori colonna dei 2 punti della linea 2
%       toll:   tolleranza in percentuale

lyaxis = [ 0 0; 0 1]; % linea asse y

olines = lines;
filtered = lines;

% calcola inclinazione con il sistema di referimento
angle1 = computeLinesAngle(l1, lyaxis, 1);
angle2 = computeLinesAngle(l2, lyaxis, 1);

% ordina gli angoli
lb = min(angle1, angle2);
ub = max(angle1, angle2);

n = 1;
m = 1;
for k = 1:length(lines)
    
    line = [lines(k).point1', lines(k).point2'];

    % calcola angolo
    theta = computeLinesAngle(line, lyaxis, 1);
    
    % filtra
    if((theta >= lb) && (theta <= ub)) % accetta linea
        olines(n) = lines(k);
        n = n +1;
    else % scarta linea
        filtered(m) = lines(k);
        m = m +1;
    end
    
    olines = olines(1:(n-1));
    filtered = filtered(1:(m-1));
end
