function [ linesAfter ] = filterLinesByIntersection( linesBefore )
%FILTERLINESBYINTERSECTION Filtra le linee per intersezione
%   Parametri:
%       linesBefore:    linee identificate

l = size(linesBefore,2);
linesAfter = linesBefore;
index = 1;
for k=1:l
    
    % imposta la retta passante per i punti estremi della linea considerata
    
    %estremi considerti
    xy1 = [linesBefore(k).point1; linesBefore(k).point2];
    
    % punti estremi in coordinate omogenee
    p_h = [xy1(1,1) xy1(1,2) 1];
    q_h = [xy1(2,1) xy1(2,2) 1];
    
    % retta passante per i due punti
    lpq_h = cross(p_h,q_h);
    
    % calcola la lunghezza del segmento
    lenghtLine1 = abs(norm(xy1(1,:)-xy1(2,:)));
    
    maxPos = k;
    
    for j= 1:l
       if(j~=k)
           
           % imposta la retta passante per i punti estremi della seconda
           % linea considerata
           xy2 = [linesBefore(j).point1; linesBefore(j).point2]; 

           % punti estremi in coordinate omogenee
           pp_h = [xy2(1,1) xy2(1,2) 1];
           qq_h = [xy2(2,1) xy2(2,2) 1];
           
           % retta passante per i due punti
           lppqq_h = cross(pp_h,qq_h);
           
           % ricerca del punto intersezione tra le due rette considetate
           intersect_h = cross(lpq_h, lppqq_h);
           intersect_c = intersect_h ./ intersect_h(3);
           intersect_c = intersect_c(1:2);
           
           % lunghezza del secodo segmente considerato
           lenghtLine2 = abs(norm(xy2(1,:)-xy2(2,:)));
       
           % controlla se il punto di intersezione appartiene ai segmenti
           % considerati
           if((isPointInSegmentBounds(p_h(1:2),q_h(1:2),intersect_c) == 1) && (isPointInSegmentBounds(pp_h(1:2),qq_h(1:2),intersect_c) == 1))
               
               % controlla se il segmento considerato fino ad ora ha
               % lunghezza superiore
               if(lenghtLine2 > lenghtLine1)
                   
                   maxPos = j;

                   % reimposta i valori del riferimento considerato massimo
                   % per i successivi confronti
                   xy1 = [linesBefore(maxPos).point1; linesBefore(maxPos).point2];
                   p_h = [xy1(1,1) xy1(1,2) 1];
                   q_h = [xy1(2,1) xy1(2,2) 1];
                   lpq_h = cross(p_h,q_h);
                   lenghtLine1 = abs(norm(xy1(1,:)-xy1(2,:)));
               end
           end
       end
    end
    
    % aggiunge la linee di indice k solo se il segmento pi lungo tra
    % quelli che lo intesecano (questo deve essere fatto al fine di non
    % aver duplicazioni di linee)
    if(maxPos == k)
        linesAfter(index) = linesBefore(maxPos);
        index = index + 1;
    end
end

% ridimensione la struct di uscita solamente con le linee effettivamente
% trovate
index = index - 1;
linesAfter = linesAfter(1:index);