function [ lines ] = findLines( BW, fillGap, minLengthHoughlines, thHoughpeaks)
%FINDLINES Identifica le linee utilizzando la trasformazione Hough
%   Parametri:
%       BW:                     maschera dell'immagine
%       fillGap:                fillGap da applicare alla funzione Houghlines
%       minLengthHoughlines:	minLength da applicare alla funzione Houghlines
%       thHoughpeaks:           threshold da applicare alla funzione Houghpeaks
%                               se uguale a -1 sigifica che bisogna usare
%                               il valore di default della funzione

%calcolo la hough
[H,T,R] = hough(BW);

%ricerca i peaks
if(thHoughpeaks == -1)
    P  = houghpeaks(H,100);
else
    P  = houghpeaks(H,100,'threshold',thHoughpeaks);
end

%imposta theta e rho
x = T(P(:,2));
y = R(P(:,1));

% Cerca le linee
lines = houghlines(BW,T,R,P,'FillGap',fillGap,'MinLength',minLengthHoughlines);

return