function [ angle ] = computeLinesAngle( l1, l2, l2isref )
%COMPUTELINEANGLE Calcola l'angolo (in radianti) fra due rette
%   Parametri:
%       l1: matrice di vettori colonna dei 2 punti della prima linea
%       l2: matrice di vettori colonna dei 2 punti della seconda linea

%l2 = [ 0 0; 0 1]; % y
%l2 = [ 0 1; 0 0]; % x

sign = 1;

if(nargin < 3)
    l2isref = 0;
end

if(l2isref)
    % calcola il coeff.angolare della linea
    diff = l1(:,1) - l1(:,2);
    slope = diff(2)/diff(1);
    
    if(slope < 0)
        sign = -1;
    end
end

% calcola delta
d1 = l1(:,2) - l1(:,1);
d2 = l2(:,2) - l2(:,1);

% calcola modulo
mod1 = sqrt(d1(1)^2 + d1(2)^2);
mod2 = sqrt(d2(1)^2 + d2(2)^2);

% calcola costheta e angolo
costheta = dot(d1, d2) ./ (mod1 .* mod2);
angle = acos(costheta);

% l'angolo calcolato  compreso fra 0 e pi
% normalizza fra 0 e pi/2
if(angle > pi/2)
    angle = pi - angle;
end

angle = sign * angle;


% direzioni concordi
%angle1 = computeLinesAngle(l1); % l1 -> linea direzione strada
%angle2 = computeLinesAngle(l2); % l2 -> altra linea direzione strada

%if((angle1 * angle2) < 0) % direzioni discordi
%    angle = computeLinesAngle(l1,l) % l -> linea da filtrare
%    if(angle < 0)
%        angle = computeLinesAngle(l2,l);
%        
%    else
%        
%        
%    end
%    
%else %direzioni concordi
%    lb = min(angle1, angle2);
%    ub = max(angle1, angle2);
%    angle = computeLineAngle(l); % l -> linea da filtrare
    
%    if((angle >= lb) && (angle <= ub))
%        accetta
%    else
%        rifiuta
%    end
%end
%