function [ value ] = inputbox( message, cancelAllowed )
%INPUTBOX Visualizza la finestra per l'inserimento
%   Parametri:
%       message:        messaggio da visualizzare
%       cancelAllowed:  indica se  possibile premere 'cancel' per
%                       annullare l'immissione

if(nargin < 2)
    cancelAllowed = 0;
end

if(~ischar(message))
    error('message must be a char array.');
end

if((~isnumeric(cancelAllowed))||((cancelAllowed < 0)||(cancelAllowed > 1)))
    error('cancelAllowed must be a boolean.');
end

while(1)
    answ = inputdlg(message);
    
    % se richiesto e permesso, esci
    if(cancelAllowed)
        if(isempty(answ))
            break;
        end
    end
    
    % acquisisci
    value = str2double(answ);
    if(~isnan(value))
        break;
    end
end
