function [ ] = plotLine( points, lineColor, lineWidth, lineStyle, marker1, marker2 )
%PLOTLINE Disegna una linea a partire da due punti
%   Parametri:
%       points: matrice di coppie di vettori colonna dei punti della linea (cord.cartesiane)

if(nargin < 6)
    marker2 = 'none';
end

if(nargin < 5)
    marker1 = 'none';
end

if(nargin < 4)
    lineStyle = '-';
end

if(nargin < 3)
    lineWidth = 1;
end

if(nargin < 2)
    lineColor = 'k';
end

[m,n] = size(points);

if(mod(n, 2) ~= 0)
    error('Points column vectors must be in a pair number.');
end

k = 1;
while((k+1) <= n)
    X = points(1,k:(k+1));
    Y = points(2,k:(k+1));
    
    %line(X, Y, 'Color', lineColor, 'LineStyle', lineStyle, 'LineWidth', lineWidth, 'Marker', marker);
    line(X, Y, 'Color', lineColor, 'LineStyle', lineStyle, 'LineWidth', lineWidth);
    
    if(~strcmp(marker1, 'none'))
        hold on;
        plot(X(1), Y(1), marker1)
    end
    if(~strcmp(marker2, 'none'))
        hold on;
        plot(X(2), Y(2), marker2)
    end
    
    k = k +2;
end
