function [ ] = plotReferenceSegment( p1, p2, length, unitLabel, textColor, textSize )
%PLOTREFERENCESEGMENT Visualizza il segmendo di riferimento
%   Parametri:
%       p1:         vettore colonna primo punto
%       p2:         vettore colonna secondo punto
%       length:     lunghezza riferimento
%       unitLabel:  etichetta unit di misura
%       textColor:  colore testo
%       textSize:   dimensione carattere

if(nargin < 6)
    textSize = 10;
end

if(nargin < 5)
    textColor = 'k';
end

plotLine([p1 p2], textColor, 2);

string = sprintf('%3.2f %s', length, unitLabel);
plotText(p1, p2, horzcat('\leftarrow', string), textColor, textSize);
