function [ pts ] = selectPoints( npoints, message )
%SELECTPOINTS Permette la selezione di punti dell'immagine
%   Parametri:
%       npoints:    numero di punti da selezionare
%       message:    messaggio da visualizzare

if((~isnumeric(npoints))||(npoints < 1))
    error('npoints must be a valid number > 0');
end

if(~ischar(message))
    error('message must be a char array.');
end

% visualizza messaggi
disp(sprintf(message));
msgbox(sprintf(message),'modal');

% cattura punti
xpts = {};
while(size(xpts) < npoints)
    [xpts, ypts] = getpts();
    pts_c = [xpts'; ypts'];
    
    if(size(xpts) < npoints)
        msgbox(sprintf('You must select at least %d points',npoints),'Point selection..','warn','modal');
    end
end

% restituisce solo i punti necessari
pts = pts_c(:,1:npoints);
