function [ speeds ] = computeSpeed( points, v1, v2, ref, reflen, time )
%COMPUTESPEED Calcola la velocit delle linee
%   Parametri:
%       points: matrice di coppie di vettori colonna dei punti della linea(cord.cartesiane)

[m,n] = size(points);

if(mod(n, 2) ~= 0)
    error('Points column vectors must be in a pair number.');
end

speeds = zeros(1,n/2);
k = 1;
j = 1;
while((k+1) <= n)
    line = points(:,k:(k+1));
    len = computeLength(v1, v2, line, ref, reflen);
    
    % calcola: (velocit = spazio / tempo), conversione m/s -> Km/h
    speeds(j) = (len / time) * 3.6;
    
    k = k +2;
    j = j+1;
end
