function [ cars ] = streakClustering(centers, speeds, vTrasv_c, deltaAngle, deltaSpeed)
%FINDCAR Cerca l'accoppiamento migliore fra le strisce
%   Detailed explanation goes here

[m,n] = size(centers);

found = zeros(1,n);
cars = zeros(n,2);
p = centers;
t = 1;
for k = 1:n
    % linea centro(k),vanishing point trasversale
    l1 = [vTrasv_c p(:,k)];
    
    % trova centro compatibile pi vicino
    indexMin = -1;
    min = inf;
    for j = [1:(k-1) (k+1):n]
        % linea tra il centro(k),centro candidato
        l2 = [p(:,k) p(:,j)];
        
        % ancolo fra le linee
        angle = computeLinesAngle(l1,l2);
        
        % distanza fra centro(k) e candidato
        dist = norm(p(:,k)-p(:,j));
        
        % verifica se compatibili
        if((angle < deltaAngle) && (abs(speeds(k)-speeds(j)) < deltaSpeed) && (dist < min))
            indexMin = j;
            min = dist;
        end
    end
    if(indexMin ~=-1) % se trovato almeno uno
        if(found(k)==0 || found(indexMin) == 0)
            found(k) = 1;
            found(indexMin) = 1;
            cars(t,:) = [k indexMin];
            t = t +1;         
        end
    end
end
t= t -1;
cars = cars(1:t,:);
