close all;
clear;

% aggiungi le path richieste per l'esecuzione
addpath(genpath(horzcat(cd, '\shots')));
addpath(horzcat(cd, '\common'));

% inizializza
figMasked = 0;
figThreshold = 0;
figBwmorpher = 0;
figStreaks = 0;
figCars = 0;
th = 0.6;

% @@@@@@@ SCELTA DATASET @@@@@@@

% knownspeed
%filename = 'tach25Kmh-2.5sec';
%filename = 'tach40Kmh-2.5sec';
%filename = 'tach50Kmh-2.5sec';
%filename = 'gps37Kmh-1sec';
%filename = 'gps37Kmh-1sec (2)';
filename = 'gps37Kmh-2sec';
%filename = 'gps38Kmh-2sec';
%filename = 'gps43Kmh-2.5sec';

% unknownspeed
%filename = 'malpensa-1sec';
%filename = 'malpensa-1sec (2)';
%filename = 'malpensa-2sec';
%filename = 'malpensa (overlapped)';
%filename = 'europa-2sec';
%filename = 'ufficio-2.5sec';

% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

% ###### PARAMETRI SCRIPT #######

choseImageParams = 0;   %0 -> usa i parametri preconfigurati
                        %1 -> scegli parametri (non usare preconfig.)
                        
doApproach = 1;         %[1] = esegue approccio A
                        %[2] = esegue approccio B
                        
chooseThreshold = 0;    %0 -> usa threshold preconfigurato
                        %1 -> scegli threshold (non usare preconfig.)
                        
chooseMorph = 0;        %0 -> usa bwmorph preconfigurato
                        %1 -> scegli bwmorph (non usare preconfig.)
                        
showMaskedImage = 1;    %0 -> visualizza immagine mascherata
                        %1 -> non visualizzare
                        
showComputation = 1;    %0 -> visualizza computazione
                        %1 -> non visualizzare
                        
% ###############################
% #### PARAMETRI APPROCCIO A ####

streakHeight = 13;      % numero (dispari) di linee di pixel considerate
                        % nell'analisi (centroid al centro)
                        
boxScalefactor = 1.3;   % fattore di ridimensionamento

applyBoxing = 1;        %0 -> applica ritaglio sull'immagine della striscia
                        %1 -> non applicare ritaglio

acfOn = 2;              %[1] = calcola l'acf sull'immagine bw threshold
                        %[2] = calcola l'acf sull'immagine rgb2gray+2double

maxBlobs = 30;          % NON MODIFICARE (ma, pi macchine -> pi blobs)
                        % numero massimo di blobs da considerare
                        
blobsThreshold = 0.005; % NON MODIFICARE
                        % percentuale, rispetto all'area massima dei blobs
                        % trovati, che determina la soglia minima per
                        % considerare valido un blob. Le aree inferiori
                        % alla soglia vengono scartate
                        
% ###############################
% #### PARAMETRI APPROCCIO B ####

houghFillGap = 50;      % parametro fillgap houghlines
houghMinLength = 60;    % parametro minlength houghlines

% ###############################
% #### PARAMETRI CLUSTERING #####

minSpeed = 10;          % limite minimo di velocit (in Km/h)
maxSpeed = 300;         % limite massimo di velocit (in Km/h)
deltaAngle = pi/18;     % limite massimo angolo sotteso fra la retta
                        % centro1-vanishing point e la retta centro1-centro2
deltaSpeed = 15;        % limite massimo differenza di velocit

% ###############################

% carica immagine
im = imread(horzcat(filename, '.jpg'));
imd = im2double(rgb2gray(im));

% visualizza
figStreaks = figure('Name','Streaks found','NumberTitle','off');
imshow(im);

% imposta parametri
shotsSettings;

% input..
if(choseImageParams)
    % selezionare due linee (due punti per linea) 
    % nella direzione longitudinale
    longit_c = selectPoints(4,'Selezionare due linee lungo da direzione longitudinale.\n( NB: DUE PUNTI PER LINEA )\n\nPoi premere ENTER..');
    
    % selezionare due linee (due punti per linea)
    % nella direzione trasversale
    trasv_c = selectPoints(4,'Selezionare due linee lungo da direzione ortogonale.\n( NB: DUE PUNTI PER LINEA )\n\nPoi premere ENTER..');
end

% calcola vanishing point
longit_h = cart2homo(longit_c);
trasv_h = cart2homo(trasv_c);
v1_h = cross(cross(longit_h(:,1), longit_h(:,2)), cross(longit_h(:,3), longit_h(:,4)));
v2_h = cross(cross(trasv_h(:,1), trasv_h(:,2)), cross(trasv_h(:,3), trasv_h(:,4)));
v1_c = homo2cart(v1_h);
v2_c = homo2cart(v2_h);

% input..
if(choseImageParams)
    % selezionare il riferimento
    ref_c = selectPoints(2,'Selezionare il segmento rappresentante la misura di riferimento.\n( NB: DUE PUNTI )(Parallelo alla misura da effettuare)\n\nPoi premere ENTER..');
    
    % lunghezza del riferimento
    reflen = inputbox('Inserire la lunghezza(m) del riferimento:');
    
    % tempo esposizione
    shutter = inputbox('Inserire il tempo(s) di esposizione:');
end

% disegna linee strada, riferimento
plotLine(longit_c,'y',2,'-');
plotReferenceSegment(ref_c(:,1), ref_c(:,2), reflen,'m', 'b', 12);

% calcola maschera
imbwmask = road2mask(imd, v1_c, longit_c);

% mascheratura
immasked = imd .* imbwmask;
%immasked = imd & imbwmask;

% visualizza immagine mascherata
if(showMaskedImage)
    figMasked = figure('Name','Masked image','NumberTitle','off');
    imshow(immasked);
    
    figure(figStreaks);
end

% thresholding
global curr;
if(chooseThreshold)
    figThreshold = threshold(immasked); % threshold
    input('Premere un tasto per continuare..');
    immasked = immasked > curr;
    close(figThreshold);
else
    immasked = immasked > th;
end

% trasformazioni morfologiche
global immorph;
if(chooseMorph)
    figBwmorpher = bwmorpher(immasked); % bwmorpher
    input('Premere un tasto per continuare..');
    immasked = immorph;
    close(figBwmorpher);
else
    % rimuovi pixel isolati
    immasked = bwmorph(immasked, 'clean');
    % buon compromesso
    immasked = bwmorph(immasked, 'close');
    immasked = bwmorph(immasked, 'erode');
    immasked = bwmorph(immasked, 'dilate');
    
    % originale
    %immasked = bwmorph(immasked, 'dilate');
    %immasked = bwmorph(immasked, 'erode');
    %immasked = bwmorph(immasked, 'dilate');

    immasked = bwmorph(immasked, 'skel');
    immasked = bwmorph(immasked, 'dilate');
end

% esegui approccio per l'identificazione tracce
switch(doApproach)
    case 1
        % aggiungi le path richieste per l'esecuzione
        addpath(horzcat(cd, '\approachA'));
        
        % esegui..
        approachA;
    case 2
        % aggiungi le path richieste per l'esecuzione
        addpath(horzcat(cd, '\approachB'));
        
        % esegui..
        approachB;
end

% identifica le auto
cars = streakClustering(ocenters, ospeeds, v2_c, deltaAngle, deltaSpeed);

% stampa identificazione
figCars = figure('Name','Cars found','NumberTitle','off');
imshow(im);
hold on;

[n,m] = size(cars);
for k = 1:n
    index1 = cars(k,1);
    index2 = cars(k,2);
    plotCar(ostreaks(:,:,index1), ostreaks(:,:,index2), ospeeds(index1), ospeeds(index2));
end
